#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <shop>

#define PLUGIN_VERSION	"1.0"

#define CATEGORY	"ability"
#define ITEM		"Скорость"

new Handle:g_hSpeed, Float:g_fSpeed,
	Handle:g_hPrice, g_iPrice;

new bool:HasSpeed[MAXPLAYERS+1];

public Plugin:myinfo =
{
	name = "[Shop] Speed",
	author = "FrozDark (HLModders LLC)",
	description = "Speed ability",
	version = PLUGIN_VERSION,
	url = "http://www.hlmod.ru/"
};

public OnPluginStart()
{
	g_hSpeed = CreateConVar("sm_shop_speed_amount", "1.2", "Speed amount. 1.0 - normal.", 0, true, 0.1);
	g_fSpeed = GetConVarFloat(g_hSpeed);
	HookConVarChange(g_hSpeed, OnConVarChange);
	
	g_hPrice = CreateConVar("sm_shop_speed_price", "10000", "The price for the speed ability.");
	g_iPrice = GetConVarInt(g_hPrice);
	HookConVarChange(g_hPrice, OnConVarChange);
	
	AutoExecConfig(true, "shop_speed", "shop");
	
	HookEvent("player_spawn", PlayerSpawn);
	
	if (Shop_IsConnected()) Shop_OnConnected();
}

public OnPluginEnd()
{
	Shop_RemoveItemFromCategory(CATEGORY, ITEM);
}

public Shop_OnAuthorized(client)
{
	HasSpeed[client] = Shop_HasItem(client, CATEGORY, ITEM);
}

public OnClientDisconnect_Post(client)
{
	HasSpeed[client] = false;
}

public Shop_OnConnected()
{
	Shop_RegisterCategory(CATEGORY, "Способности", OnCategoryRegistered);
}

public OnCategoryRegistered(const String:category[], const String:name[])
{
	decl String:buffer[64];
	strcopy(buffer, sizeof(buffer), category);
	
	Shop_AddItemToCategory(buffer, ITEM, EmptyHandler, g_iPrice, false, false, false, OnItemRegistered, OnBuy, OnSell);
}

public OnItemRegistered(const String:category[], const String:item[], const String:error[])
{
	if (error[0])
	{
		LogError(error);
	}
}

public Action:OnBuy(client, const String:category[], const String:item[], &credits)
{
	HasSpeed[client] = true;
	SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", g_fSpeed);
}

public Action:OnSell(client, const String:category[], const String:item[], &credits)
{
	HasSpeed[client] = false;
	SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", 1.0);
}

public OnConVarChange(Handle:convar, const String:oldValue[], const String:newValue[])
{
	if (convar == g_hSpeed)
	{
		g_fSpeed = StringToFloat(newValue);
	}
	else if (convar == g_hPrice)
	{
		g_iPrice = StringToInt(newValue);
		Shop_SetItemPrice(CATEGORY, ITEM, g_iPrice);
	}
}

public ShopReturnTypes:EmptyHandler(client, const String:category[], const String:item[], bool:toggledOn)
{
}

public PlayerSpawn(Handle:event,const String:name[],bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	
	if (!client) return;
	
	CreateTimer(0.0, SetSpeed, client);
}

public Action:SetSpeed(Handle:timer, any:client)
{
	if (HasSpeed[client])
	{
		SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", g_fSpeed);
	}
	else
	{
		SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", 1.0);
	}
}